//PP19 Drill
// 1. Define template<typename T> struct S { T val; };.
// 2. Add a constructor, so that you can initialize with a T.
// 3. Define variables of types S<int>, S<char>, S<double>, S<string>, and S<vector<int>>;
//    initialize them with values of your choice.
// 4. Read those values and print them.
// 5. Add a function template get() that returns a reference to val.
// 9. Add a set() function template so that you can change val.
//10. Replace set() with an S<T>::operator=(const T&). Hint: Much simpler than 19.2.5.
//11. Provide const and non-const versions of get().
//12. Define a function template<typename T> read_val(T& v) that reads from cin into v.
//13. Use read_val() to read into each of the variables from 3 except the S<vector<int>>
//    variable.
//14. Bonus: Define input and output operators (>> and <<) for vector<T>s. For both input and
//    output use a{ val, val, val } format.That will allow read_val() to also handle the
//    S<vector<int>> variable.

#include <iostream>
#include <map>
#include <string>
#include <vector>
using std::istream;
using std::ostream;
using std::cout;
using std::cin;
using std::pair;
using std::string;
using std::vector;


template<class T>
struct S {				      // Drill 1
public:
	S() : value(T()) { }
	S(T d) : value(d) { }     // Drill 2
	T getValue() { return value; }
	T& get();				  // Drill 5
	const T& get() const;				  // Drill 5
	void set(const T&);
	T& operator=(const T&);
private:
	T value;
};

// Drill 12
template<class T>
istream& operator>>(istream& ins, S<T>& s) {
	T v;
	cin >> v;
	if (!ins) return ins;
	s = v;
	return ins;
}

template<class T>
void read_val(T& v) {
	cin >> v;
}

template<class T>
T& S<T>::get() { return value; }

template<class T>
const T& S<T>::get() const { return value; }


template<class T>
void S<T>::set(const T& t) {
	value = t;
} // : value(t) { }

template<class T>
T& S<T>::operator=(const T& t) {
	value = t;
	return value;
}

// -----------------------------------------------------------------------------

// Drill 14
template<class T> 
ostream& operator<<(ostream& os, const vector<T>& vt) {
	os << "{ ";
	for (int i = 0; i < vt.size(); ++i) {
		os << vt[i];
		if (i < vt.size() - 1) os << ',';
		os << ' ';
	}
	os << "}";
	return os;
}

template<class T> 
istream& operator>>(istream& is, vector<T>& vt) {
	char ch1, ch2;
	T temp;
	vector<T> vtemp;
	is >> ch1;
	if (!is) return is;
	if (ch1 != '{') {
		is.clear(ios_base::failbit);
		return is;
	}
	while (cin >> temp >> ch2 && ch2 == ',') {
		vtemp.push_back(temp);
	}
	if (ch2 != '}') {
		is.clear(ios_base::failbit);
		return is;
	}
	vtemp.push_back(temp); // ch2=='}', read last value

	// copy vtemp vector only now so vt is not changed if input fails
	vt = vtemp;
}

int main() {
	S<char> s0(42);
	S<pair<string, double>> s1();
	S<int> s2(42);
	S<double> s3(1234.56e-78);
	S<string> s4("catdog");
	S<vector<int>> s5({ 1,2,3,4,5 });
	cout << "s0.getValue() = " << s0.getValue() << '\n';
	//cout << "s1.getValue() = " << s1.getValue() << '\n'; //default value?
	cout << "s2.getValue() = " << s2.getValue() << '\n';
	cout << "s3.getValue() = " << s3.getValue() << '\n';
	cout << "s4.getValue() = " << s4.getValue() << '\n';
	cout << "s5.getValue()[0] = " << s5.getValue()[0] << '\n';
	cout << "s5.get()[1] = " << s5.get()[1] << '\n';
	s5.set({ 42 });
	cout << "s5.get()[0] = " << s5.get()[0] << '\n';
	S<vector<int>> s6 = s5;
	cout << "s6.get()[0] = " << s6.get()[0] << '\n';

	// Drill 13
	cout << "\ns0 (char): ";
	read_val(s0);
	//cout << "s1 (pair<string,double>): ";
	//read_val(s1);
	cout << "s2 (int): ";
	read_val(s2);
	cout << "s3 (double): ";
	read_val(s3);
	cout << "s4 (string): ";
	read_val(s4);
	cout << "\ns0: " << s0.get() << "\n";
	//cout << "s1: " << s1.get().first << ',' << s1.get().second << "\n";
	cout << "s2: " << s2.get() << "\n";
	cout << "s3: " << s3.get() << "\n";
	cout << "s4: " << s4.get() << "\n\n";

	// Drill 14

	cout << "\ns5 (vector<int>): ";
	read_val(s5);
	cout << "\ns_v_int: " << s5.get() << "\n";
}
